# debuginfo not supported with Go
%global debug_package %{nil}
# modifying the Go binaries breaks the DWARF debugging
%global __os_install_post %{_rpmconfigdir}/brp-compress

%global gopath          %{_datadir}/gocode
%global import_path     github.com/openshift/rosa
%global golang_version  1.14

Name:           rosa
Version:        1.0.9
Release:        9c22c2c%{?dist}
Summary:        ROSA client binaries
License:        ASL 2.0
URL:            https://github.com/openshift/rosa

Source0: rosa-9c22c2cd61da100d497775fa2638ab8b0720aa51.tar.gz

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:  x86_64 aarch64 ppc64le s390x
%endif

BuildRequires:  golang >= %{golang_version}
Requires:       bash-completion

%description
[Maintainer] product: Red Hat OpenShift Service on AWS, component: rosa
%{summary}

%package redistributable
Summary:        ROSA Client binaries for Linux, Mac OSX, and Windows

%description redistributable
[Maintainer] product: Red Hat OpenShift Service on AWS, component: rosa
%{summary}

%prep
%setup -q -n rosa-9c22c2cd61da100d497775fa2638ab8b0720aa51

%build
mkdir -p "$(dirname __gopath/src/%{import_path})"
mkdir -p "$(dirname __gopath/src/%{import_path})"
ln -s "$(pwd)" "__gopath/src/%{import_path}"
export GOPATH=$(pwd)/__gopath:%{gopath}
cd "__gopath/src/%{import_path}"

%ifarch %{ix86}
GOOS=linux
GOARCH=386
%endif
%ifarch ppc64le
GOOS=linux
GOARCH=ppc64le
%endif
%ifarch %{arm} aarch64
GOOS=linux
GOARCH=arm64
%endif
%ifarch s390x
GOOS=linux
GOARCH=s390x
%endif
%ifarch x86_64
  # Create Binaries for all supported arches
  GOARCH=amd64
  GOOS=darwin go build -o rosa-darwin ./cmd/rosa
  GOOS=windows go build -o rosa.exe ./cmd/rosa
  GOOS=linux
%endif
make rosa

%install
install -d %{buildroot}%{_bindir}

# Install for the local platform
install -p -m 755 ./rosa %{buildroot}%{_bindir}/rosa
[[ -e %{buildroot}%{_bindir}/rosa ]]

%ifarch x86_64
# Install client executable for windows and mac
install -d %{buildroot}%{_datadir}/%{name}/{linux,macosx,windows}
install -p -m 755 ./rosa %{buildroot}%{_datadir}/%{name}/linux/rosa
install -p -m 755 ./rosa-darwin %{buildroot}%{_datadir}/%{name}/macosx/rosa
install -p -m 755 ./rosa.exe %{buildroot}%{_datadir}/%{name}/windows/rosa.exe
%endif

# Install man1 man pages
install -d -m 0755 %{buildroot}%{_mandir}/man1
./rosa docs -f man -d %{buildroot}%{_mandir}/man1

 # Install bash completions
install -d -m 755 %{buildroot}%{_sysconfdir}/bash_completion.d/
for bin in rosa
do
  echo "+++ INSTALLING BASH COMPLETIONS FOR ${bin} "
  %{buildroot}%{_bindir}/${bin} completion > %{buildroot}%{_sysconfdir}/bash_completion.d/${bin}
  chmod 644 %{buildroot}%{_sysconfdir}/bash_completion.d/${bin}
done

%files
%license LICENSE
%{_bindir}/rosa
%{_sysconfdir}/bash_completion.d/rosa
%dir %{_mandir}/man1/
%{_mandir}/man1/rosa*

%ifarch x86_64
%files redistributable
%license LICENSE
%dir %{_datadir}/%{name}/linux/
%dir %{_datadir}/%{name}/macosx/
%dir %{_datadir}/%{name}/windows/
%{_datadir}/%{name}/linux/rosa
%{_datadir}/%{name}/macosx/rosa
%{_datadir}/%{name}/windows/rosa.exe
%endif

%changelog
